## okteta 0.25.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project( okteta )

set(REQUIRED_ECM_VERSION "5.38.0")
find_package(ECM ${REQUIRED_ECM_VERSION} REQUIRED NO_MODULE)

# where to look first for cmake modules, before ${CMAKE_ROOT}/Modules/ is checked
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH} ${ECM_KDE_MODULE_DIR})

# ECM KDE macros (include first, to have their policies and settings effect all other macros)
include(KDEInstallDirs)
include(KDECMakeSettings NO_POLICY_SCOPE)
include(KDECompilerSettings NO_POLICY_SCOPE)
# ECM macros
include(ECMInstallIcons)
include(ECMGenerateHeaders)
include(ECMSetupVersion)
include(ECMAddAppIcon)
# CMake macros
include(FeatureSummary)
include(GenerateExportHeader)
include(CMakeDependentOption)
if(BUILD_TESTING)
  include(ECMAddTests)
endif()

# control build scope, default to examples if BUILD_TESTING is ON
if( NOT DEFINED OMIT_EXAMPLES AND NOT BUILD_TESTING )
    set( OMIT_EXAMPLES TRUE )
endif()
if( NOT DEFINED OMIT_INTERNAL_TEMPLATES AND NOT BUILD_TESTING )
    set( OMIT_INTERNAL_TEMPLATES TRUE )
endif()

if( NOT OMIT_EXAMPLES )
    set( OKTETA_BUILD_EXAMPLES TRUE )
endif()
if( NOT OMIT_INTERNAL_TEMPLATES )
    set( KASTEN_BUILD_INTERNAL_TEMPLATES TRUE )
endif()

option(BUILD_DESIGNERPLUGIN "Build the Designer plugin." ON)
add_feature_info(DESIGNERPLUGIN ${BUILD_DESIGNERPLUGIN} "Qt Designer plugin")
option(BUILD_OKTETAKASTENLIBS "Build the Okteta Kasten libraries." ON)
add_feature_info(OKTETAKASTENLIBS ${BUILD_OKTETAKASTENLIBS} "Okteta Kasten libraries")

cmake_dependent_option(BUILD_KPARTSPLUGIN "Build the KParts plugin." ON "BUILD_OKTETAKASTENLIBS" OFF)
add_feature_info(KPARTSPLUGIN ${BUILD_KPARTSPLUGIN} "KParts plugin")
cmake_dependent_option(BUILD_DESKTOPPROGRAM "Build the program." ON "BUILD_OKTETAKASTENLIBS" OFF)
add_feature_info(DESKTOPPROGRAM ${BUILD_DESKTOPPROGRAM} "Program")

set(REQUIRED_QT_VERSION "5.9.0")
set(ADDITIONAL_REQUIRED_QT_COMPONENTS)
if(BUILD_TESTING)
    list(APPEND ADDITIONAL_REQUIRED_QT_COMPONENTS Test)
endif()
if( BUILD_DESIGNERPLUGIN )
    list(APPEND ADDITIONAL_REQUIRED_QT_COMPONENTS UiPlugin)
endif()
if( BUILD_OKTETAKASTENLIBS )
    list(APPEND ADDITIONAL_REQUIRED_QT_COMPONENTS
        Network
        PrintSupport
        Qml
        Script
        ScriptTools
        Xml
    )
endif()
find_package(Qt5 ${REQUIRED_QT_VERSION} CONFIG REQUIRED
    COMPONENTS
    Core
    Widgets
    ${ADDITIONAL_REQUIRED_QT_COMPONENTS}
)

set(REQUIRED_KF5_VERSION "5.38.0")
set(ADDITIONAL_REQUIRED_KF_COMPONENTS)
if( BUILD_OKTETAKASTENLIBS )
    list(APPEND ADDITIONAL_REQUIRED_KF_COMPONENTS
        Bookmarks
        Completion
        IconThemes
        KCMUtils
        KIO
        NewStuff
        Parts
        Service
        WidgetsAddons
        XmlGui
    )
endif()
if( BUILD_DESKTOPPROGRAM )
    list(APPEND ADDITIONAL_REQUIRED_KF_COMPONENTS
        Crash
        DBusAddons
        DocTools
    )
endif()
find_package(KF5 ${REQUIRED_KF5_VERSION} REQUIRED
    COMPONENTS
    Codecs
    ConfigWidgets
    I18n
    ${ADDITIONAL_REQUIRED_KF_COMPONENTS}
)

find_package(Qca-qt5 2.1.0)
set_package_properties(Qca-qt5 PROPERTIES DESCRIPTION "Qt Cryptographic Architecture"
                       URL "http:/download.kde.org/stable/qca-qt5" TYPE OPTIONAL
                       PURPOSE "Needed for most of the algorithms of the checksum tool")

add_definitions(
    -DQT_DEPRECATED_WARNINGS
    -DQT_DISABLE_DEPRECATED_BEFORE=0x050900
    -DQT_USE_QSTRINGBUILDER
    -DQT_NO_CAST_TO_ASCII
    -DQT_NO_CAST_FROM_ASCII
    -DQT_NO_CAST_FROM_BYTEARRAY
    -DQT_STRICT_ITERATORS
    -DQT_NO_URL_CAST_FROM_STRING
    -DQT_NO_SIGNALS_SLOTS_KEYWORDS
    -DQT_NO_NARROWING_CONVERSIONS_IN_CONNECT
)

# helper libs
add_subdirectory( libs )
if( BUILD_DESKTOPPROGRAM )
    add_subdirectory( doc )
endif()

set( OKTETALIBS_MAJOR_VERSION 0 )
set( OKTETALIBS_MINOR_VERSION 9 )
set( OKTETALIBS_PATCHLEVEL_VERSION 1 )
set( OKTETALIBS_VERSION "${OKTETALIBS_MAJOR_VERSION}.${OKTETALIBS_MINOR_VERSION}.${OKTETALIBS_PATCHLEVEL_VERSION}" )
set( OKTETALIBS_ABI_VERSION 2 )
set( OKTETALIBS_INCLUDE_INSTALL_DIR  ${KDE_INSTALL_INCLUDEDIR}/okteta ) #${OKTETALIBS_ABI_VERSION} )
set( OKTETALIBS_CCINCLUDE_INSTALL_DIR  ${KDE_INSTALL_INCLUDEDIR}/Okteta ) #${OKTETALIBS_ABI_VERSION} )

set( OKTETALIBS_LIB_SOVERSION ${OKTETALIBS_ABI_VERSION} )
set( OKTETALIBS_LIB_VERSION ${OKTETALIBS_VERSION} )

# Okteta libs
add_subdirectory( core )
add_subdirectory( gui )

if( BUILD_DESIGNERPLUGIN )
    add_subdirectory( designer )
endif()

# Okteta Kasten components
if( BUILD_OKTETAKASTENLIBS )
    add_subdirectory( kasten )
endif()
# special mimetypes
if( BUILD_OKTETAKASTENLIBS )
    add_subdirectory( mimetypes )
endif()

# programs and parts for desktop
add_subdirectory( parts )
if( BUILD_DESKTOPPROGRAM )
    add_subdirectory( program )
endif()

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

find_package(KF5I18n CONFIG REQUIRED)
ki18n_install(po)

  find_package(KF5DocTools CONFIG)
  if(KF5DocTools_FOUND)
    kdoctools_install(po)
  endif()

=== core/CMakeLists.txt ===
ecm_setup_version( ${OKTETALIBS_LIB_VERSION}
    VARIABLE_PREFIX OKTETACORE
    SOVERSION ${OKTETALIBS_LIB_SOVERSION}
    PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/OktetaCoreConfigVersion.cmake"
)

add_definitions(-DTRANSLATION_DOMAIN=\"liboktetacore\")

set( libcontroller_SRCS
  controller/kchareditor.cpp
  controller/kcontroller.cpp
  controller/keditor.cpp
  controller/knavigator.cpp
  controller/ktabcontroller.cpp
  controller/kvalueeditor.cpp
)

set(libcodecs_SRCS
  codecs/binarybytecodec.cpp
  codecs/valuecodec.cpp
  codecs/charcodec.cpp
  codecs/decimalbytecodec.cpp
  codecs/usasciicharcodec.cpp
  codecs/ebcdic1047charcodec.cpp
  codecs/jisx0201charcodec.cpp
  codecs/hexadecimalbytecodec.cpp
  codecs/octalbytecodec.cpp
  codecs/textcharcodec.cpp
)

set( libpiecetable_SRCS
  piecetable/piecelist.cpp
  piecetable/piecetable.cpp
  piecetable/abstractpiecetablechange.cpp
#   piecetable/fillpiecetablechange.cpp
  piecetable/insertpiecetablechange.cpp
  piecetable/removepiecetablechange.cpp
  piecetable/replacepiecetablechange.cpp
  piecetable/swaprangespiecetablechange.cpp
  piecetable/grouppiecetablechange.cpp
  piecetable/piecetablechangehistory.cpp
  piecetable/revertablepiecetable.cpp
)

set( oktetacore_LIB_SRCS
  ${libcodecs_SRCS}
  ${libpiecetable_SRCS}
  oktetacore.cpp
  abstractbytearraymodel.cpp
  bytearraymodel_p.cpp
  bytearraymodel.cpp
  fixedsizebytearraymodel.cpp
  filebytearraymodel_p.cpp
  filebytearraymodel.cpp
  piecetablebytearraymodel_p.cpp
  piecetablebytearraymodel.cpp
  wordbytearrayservice.cpp
  bookmarklistconstiteratoradapter.cpp
  bookmarklist.cpp
  addressrangelist.cpp
)

ecm_generate_headers(oktetacore_LIB_CCHDRS
  HEADER_NAMES
    OktetaCore
    Range
    NumberRange

    Address
    AddressRange
    Size
    Byte
    AbstractByteArrayModel
    Versionable
    Bookmarkable
    ChangesDescribable
    ChangeHistory

    ByteArrayModel
    #FileByteArrayModel
    PieceTableByteArrayModel

    Character
    ArrayChangeMetrics
    ArrayChangeMetricsList
    ByteArrayChange

    Bookmark
    BookmarksConstIteratorAdapter # TODO: make private or move adapter class to iterator
    BookmarksConstIterator

    WordByteArrayService
    ValueCodec
    CharCodec
  PREFIX Okteta
  REQUIRED_HEADERS oktetacore_LIB_HDRS
)
#don't compile sources twice by using object libraries
#add_library( oktetacore_objs OBJECT ${oktetacore_LIB_SRCS} )
#target_include_directories( oktetacore_objs PUBLIC $<TARGET_PROPERTY:Qt5::Core,INTERFACE_INCLUDE_DIRECTORIES> )
#set( oktetacore_LIB_OBJS $<TARGET_OBJECTS:oktetacore_objs>)

# compile flags don't get set for object libraries, since cannot link to target
#TODO: find out how to properly use targets for object libraries
set( oktetacore_LIB_OBJS ${oktetacore_LIB_SRCS} )


add_library( OktetaCore SHARED ${oktetacore_LIB_OBJS} )

generate_export_header( OktetaCore EXPORT_FILE_NAME ${CMAKE_CURRENT_BINARY_DIR}/okteta/oktetacore_export.h)

target_link_libraries( OktetaCore
PUBLIC
  Qt5::Core
PRIVATE
  KF5::I18n
  KF5::Codecs   #needed for codecs
)

target_include_directories(OktetaCore PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>")

set_target_properties( OktetaCore  PROPERTIES
  EXPORT_NAME "OktetaCore"
  OUTPUT_NAME okteta${OKTETALIBS_ABI_VERSION}core
  VERSION     ${OKTETACORE_VERSION}
  SOVERSION   ${OKTETACORE_SOVERSION}
)

install( TARGETS OktetaCore EXPORT OktetaCoreTargets ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} )

install( FILES
    ${oktetacore_LIB_HDRS}
    ${CMAKE_CURRENT_BINARY_DIR}/okteta/oktetacore_export.h
  DESTINATION ${OKTETALIBS_INCLUDE_INSTALL_DIR}
  COMPONENT Devel
)
install( FILES ${oktetacore_LIB_CCHDRS}
  DESTINATION ${OKTETALIBS_CCINCLUDE_INSTALL_DIR}
  COMPONENT Devel
)

# create a Config.cmake and a ConfigVersion.cmake file and install them
set(CMAKECONFIG_INSTALL_DIR "${KDE_INSTALL_CMAKEPACKAGEDIR}/OktetaCore")

configure_package_config_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/OktetaCoreConfig.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/OktetaCoreConfig.cmake"
  INSTALL_DESTINATION ${CMAKECONFIG_INSTALL_DIR}
)

install( FILES
    "${CMAKE_CURRENT_BINARY_DIR}/OktetaCoreConfig.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/OktetaCoreConfigVersion.cmake"
  DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
  COMPONENT Devel
)

install(EXPORT OktetaCoreTargets
  DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
  FILE OktetaCoreTargets.cmake
)


if(BUILD_TESTING)
  add_library( testoktetacore STATIC ${oktetacore_LIB_OBJS} )
  set_target_properties( testoktetacore PROPERTIES COMPILE_FLAGS -DOKTETACORE_STATIC_DEFINE )
  target_include_directories( testoktetacore PUBLIC ${CMAKE_CURRENT_BINARY_DIR} )
  target_link_libraries( testoktetacore Qt5::Core KF5::I18n KF5::Codecs )
  add_subdirectory( piecetable/tests )
  add_subdirectory( tests )
endif()

=== designer/CMakeLists.txt ===
set( oktetadesignerplugin_SRCS
  bytearraycolumnviewdesignerfactory.cpp
  bytearrayrowviewdesignerfactory.cpp
  oktetawidgetdesignerfactorycollection.cpp
  fillerbytearraymodel.cpp
)


add_library( oktetadesignerplugin  MODULE ${oktetadesignerplugin_SRCS} )

target_link_libraries( oktetadesignerplugin
  OktetaGui
  OktetaCore
  Qt5::Widgets
  Qt5::UiPlugin
)

set_target_properties( oktetadesignerplugin PROPERTIES
    OUTPUT_NAME oktetawidgets
)

install( TARGETS oktetadesignerplugin  DESTINATION ${KDE_INSTALL_QTPLUGINDIR}/designer )


if( OKTETA_BUILD_EXAMPLES )
add_subdirectory( examples )
endif( OKTETA_BUILD_EXAMPLES )

=== gui/CMakeLists.txt ===
ecm_setup_version( ${OKTETALIBS_LIB_VERSION}
    VARIABLE_PREFIX OKTETAGUI
    SOVERSION ${OKTETALIBS_LIB_SOVERSION}
    PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/OktetaGuiConfigVersion.cmake"
)

add_definitions(-DTRANSLATION_DOMAIN=\"liboktetagui\")

include_directories(
  libcolumnsview
)

set( libcontroller_SRCS
  controller/kchareditor.cpp
  controller/kcontroller.cpp
  controller/keditor.cpp
  controller/knavigator.cpp
  controller/ktabcontroller.cpp
  controller/kvalueeditor.cpp
  controller/abstractmousecontroller.cpp
  controller/mousenavigator.cpp
  controller/mousepaster.cpp
#   controller/dragger.cpp
  controller/abstractwheelcontroller.cpp
  controller/zoomwheelcontroller.cpp
  controller/dropper.cpp
)

set( libcolumnsview_SRCS
  libcolumnsview/abstractcolumnstylist.cpp
  libcolumnsview/abstractcolumnrenderer.cpp
  libcolumnsview/columnsview.cpp
)

ecm_generate_headers(libcolumnsview_CCHDRS
  HEADER_NAMES
    KAdds # TODO: this header needs to be redone
    AbstractColumnStylist
    AbstractColumnRenderer
    ColumnsView
  RELATIVE libcolumnsview
  PREFIX Okteta
  REQUIRED_HEADERS libcolumnsview_HDRS
)

set( libabstractbytearrayview_SRCS
  widgetcolumnstylist.cpp
  abstractbytearrayview_p.cpp
  abstractbytearrayview.cpp
)

set( bytearrayrowview_SRCS
  bytearrayrowcolumnrenderer.cpp
  bytearrayrowview_p.cpp
  bytearrayrowview.cpp
)

set( bytearraycolumnview_SRCS
  bytearraycolumnview_p.cpp
  bytearraycolumnview.cpp
)

set( oktetagui_LIB_SRCS
  ${libcolumnsview_SRCS}
  ${libcontroller_SRCS}
  ${libabstractbytearrayview_SRCS}
  bordercolumnrenderer.cpp
  offsetcolumnrenderer.cpp
  abstractbytearraycolumnrenderer.cpp
  valuebytearraycolumnrenderer.cpp
  charbytearraycolumnrenderer.cpp
  offsetformat.cpp
  bytearraytablecursor.cpp
  bytearraytablelayout.cpp
  bytearraytableranges.cpp
  kcursor.cpp
  coordrangelist.cpp
  ${bytearraycolumnview_SRCS}
  ${bytearrayrowview_SRCS}
  oktetagui.cpp
)

set( oktetagui_LIB_HDRS
  ${libcolumnsview_HDRS}
  ${CMAKE_CURRENT_BINARY_DIR}/okteta/oktetagui_export.h
)

set(oktetagui_LIB_CCHDRS
    ${libcolumnsview_CCHDRS}
)

ecm_generate_headers(oktetagui_LIB_CCHDRS
  HEADER_NAMES
    OktetaGui

    LinePosition
    Line
    LinePositionRange
    LineRange

    Coord
    CoordRange
    CoordRangeList
    Selection

    AbstractByteArrayColumnRenderer
    CharByteArrayColumnRenderer
    ValueByteArrayColumnRenderer
    ByteArrayRowColumnRenderer
    OffsetColumnRenderer
    BorderColumnRenderer

    AbstractByteArrayView
    ByteArrayColumnView

    OffsetFormat
    ByteArrayTableRanges
    ByteArrayRowView
    ByteArrayTableLayout
    WidgetColumnStylist
  PREFIX Okteta
  REQUIRED_HEADERS oktetagui_LIB_HDRS
)

add_library( OktetaGui  SHARED ${oktetagui_LIB_SRCS} )

generate_export_header( OktetaGui EXPORT_FILE_NAME ${CMAKE_CURRENT_BINARY_DIR}/okteta/oktetagui_export.h)

target_link_libraries( OktetaGui
PUBLIC
  OktetaCore
  Qt5::Widgets
PRIVATE
  KF5::I18n
  KF5::ConfigWidgets
)

target_include_directories(OktetaGui PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>")

set_target_properties( OktetaGui  PROPERTIES
  EXPORT_NAME "OktetaGui"
  OUTPUT_NAME okteta${OKTETALIBS_ABI_VERSION}gui
  VERSION     ${OKTETAGUI_VERSION}
  SOVERSION   ${OKTETAGUI_SOVERSION}
)

install( TARGETS OktetaGui  EXPORT OktetaGuiTargets ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} )

install( FILES ${oktetagui_LIB_HDRS}
  DESTINATION ${OKTETALIBS_INCLUDE_INSTALL_DIR}
  COMPONENT Devel
)
install( FILES ${oktetagui_LIB_CCHDRS}
  DESTINATION ${OKTETALIBS_CCINCLUDE_INSTALL_DIR}
  COMPONENT Devel
)

# create a Config.cmake and a ConfigVersion.cmake file and install them
set(CMAKECONFIG_INSTALL_DIR "${KDE_INSTALL_CMAKEPACKAGEDIR}/OktetaGui")

configure_package_config_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/OktetaGuiConfig.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/OktetaGuiConfig.cmake"
  INSTALL_DESTINATION ${CMAKECONFIG_INSTALL_DIR}
)

install( FILES
    "${CMAKE_CURRENT_BINARY_DIR}/OktetaGuiConfig.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/OktetaGuiConfigVersion.cmake"
  DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
  COMPONENT Devel
)

install(EXPORT OktetaGuiTargets
  DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
  FILE OktetaGuiTargets.cmake
)


if(BUILD_TESTING)
  add_subdirectory( test )
#   add_library( testoktetacore STATIC ${oktetagui_LIB_SRCS} )
endif()

=== kasten/controllers/CMakeLists.txt ===
set( LIBFRAMESPRINT_REL_DIR ../../libs/framesprint )

ecm_setup_version( ${OKTETAKASTEN_LIB_VERSION}
    VARIABLE_PREFIX OKTETAKASTENCONTROLLERS
    SOVERSION ${OKTETAKASTEN_LIB_SOVERSION}
    PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/OktetaKastenControllersConfigVersion.cmake"
)

add_definitions(-DTRANSLATION_DOMAIN=\"liboktetakasten\")

macro(OKTETAKASTENCONTROLLERS_GENERATE_HEADERS _SUBLIB _RELATIVE)
    ecm_generate_headers("${_SUBLIB}_CCHDRS"
        HEADER_NAMES ${ARGN}
        RELATIVE ${_RELATIVE}
        PREFIX Kasten/Okteta
        REQUIRED_HEADERS "${_SUBLIB}_HDRS"
    )
endmacro()

include_directories(
  view/libbytearraychecksum
  view/libbytearrayfilter
  view/libfinddialog
  ${LIBFRAMESPRINT_REL_DIR}
)

set(HAVE_QCA2 ${Qca-qt5_FOUND})
configure_file( config-qca2.h.cmake  ${CMAKE_CURRENT_BINARY_DIR}/config-qca2.h )

set( DOCUMENTINFOCONTROLLER_SRCS
  document/info/bytearraymodeliodevice.cpp
  document/info/documentinfotool.cpp
  document/info/documentinfoview.cpp
  document/info/documentinfotoolview.cpp
)
oktetakastencontrollers_generate_headers(documentinfocontroller document/info
  DocumentInfoTool
  DocumentInfoToolView
)
set( OVERWRITEONLYCONTROLLER_SRCS
  document/overwriteonly/overwriteonlycontroller.cpp
)
oktetakastencontrollers_generate_headers(overwriteonlycontroller document/overwriteonly
  OverwriteOnlyController
)
set( OVERWRITEMODECONTROLLER_SRCS
  view/overwritemode/overwritemodecontroller.cpp
)
oktetakastencontrollers_generate_headers(overwritemodecontroller view/overwritemode
  OverwriteModeController
)
set( INFOCONTROLLER_SRCS
  view/info/createstatisticjob.cpp
  view/info/statistictablemodel.cpp
  view/info/infotool.cpp
  view/info/infoview.cpp
  view/info/infotoolview.cpp
  view/info/infotoolfactory.cpp
  view/info/infotoolviewfactory.cpp
)
kconfig_add_kcfg_files( INFOCONTROLLER_SRCS view/info/infoviewsettings.kcfgc )
oktetakastencontrollers_generate_headers(infocontroller view/info
  InfoTool
  InfoToolView
  InfoToolFactory
  InfoToolViewFactory
)

set( STRINGSEXTRACTCONTROLLER_SRCS
  view/stringsextract/extractstringsjob.cpp
  view/stringsextract/stringsextracttool.cpp
  view/stringsextract/containedstringtablemodel.cpp
  view/stringsextract/stringsextractview.cpp
  view/stringsextract/stringsextracttoolview.cpp
  view/stringsextract/stringsextracttoolfactory.cpp
  view/stringsextract/stringsextracttoolviewfactory.cpp
)
oktetakastencontrollers_generate_headers(stringsextractcontroller view/stringsextract
  ContainedString
  StringsExtractTool
  StringsExtractToolView
  StringsExtractToolFactory
  StringsExtractToolViewFactory
)

if( Qca-qt5_FOUND )
    set( QCA2CHECKSUM_SRCS
      view/libbytearraychecksum/algorithm/qca2bytearraychecksumalgorithm.cpp
    )
endif( Qca-qt5_FOUND )
set( LIBCHECKSUM_SRCS
  view/libbytearraychecksum/abstractbytearraychecksumalgorithm.cpp
  view/libbytearraychecksum/abstractbytearraychecksumparameterset.cpp
  view/libbytearraychecksum/abstractbytearraychecksumparametersetedit.cpp
  view/libbytearraychecksum/bytearraychecksumalgorithmfactory.cpp
  view/libbytearraychecksum/bytearraychecksumparameterseteditfactory.cpp
  view/libbytearraychecksum/algorithm/crc32bytearraychecksumalgorithm.cpp
  view/libbytearraychecksum/algorithm/adler32bytearraychecksumalgorithm.cpp
  view/libbytearraychecksum/algorithm/modsum8bytearraychecksumalgorithm.cpp
  view/libbytearraychecksum/algorithm/modsum16bytearraychecksumalgorithm.cpp
  view/libbytearraychecksum/algorithm/modsum32bytearraychecksumalgorithm.cpp
  view/libbytearraychecksum/algorithm/modsum64bytearraychecksumalgorithm.cpp
## NEWCHECKSUM(start)
## Here add the names of your source files of your checksum algorithm,
## e.g.
##   view/libbytearraychecksum/algorithm/mybytearraychecksumalgorithm.cpp
## NEWCHECKSUM(end)
  view/libbytearraychecksum/algorithm/nobytearraychecksumparameterset.cpp
  view/libbytearraychecksum/algorithm/nobytearraychecksumparametersetedit.cpp
  view/libbytearraychecksum/algorithm/modsumbytearraychecksumparameterset.cpp
  view/libbytearraychecksum/algorithm/modsumbytearraychecksumparametersetedit.cpp
## NEWCHECKSUMPARAMETERSET(start)
## Here add the names of your source files of your checksum parameter set and
## of the widget to edit the checksum parameter set,
## e.g.
##   view/libbytearraychecksum/algorithm/mybytearraychecksumparameterset.cpp
##   view/libbytearraychecksum/algorithm/mybytearraychecksumparametersetedit.cpp
## NEWCHECKSUMPARAMETERSET(end)
  ${QCA2CHECKSUM_SRCS}
)
set( CHECKSUMCONTROLLER_SRCS
  view/checksum/checksumcalculatejob.cpp
  view/checksum/checksumlogging.cpp
  view/checksum/checksumtool.cpp
  view/checksum/checksumview.cpp
  view/checksum/checksumtoolview.cpp
  view/checksum/checksumtoolfactory.cpp
  view/checksum/checksumtoolviewfactory.cpp
)
oktetakastencontrollers_generate_headers(checksumcontroller view/checksum
  ChecksumTool
  ChecksumToolView
  ChecksumToolFactory
  ChecksumToolViewFactory
)

set( LIBFINDDIALOG_SRCS
  view/libfinddialog/kabstractfinddialog.cpp
)
oktetakastencontrollers_generate_headers(libfinddialog view/libfinddialog
  KFindDirection
)

set( PODDECODERCONTROLLER_SRCS
  view/poddecoder/typecodecs/binary8codec.cpp
  view/poddecoder/typecodecs/octal8codec.cpp
  view/poddecoder/typecodecs/hexadecimal8codec.cpp
  view/poddecoder/typecodecs/uint8codec.cpp
  view/poddecoder/typecodecs/uint16codec.cpp
  view/poddecoder/typecodecs/uint32codec.cpp
  view/poddecoder/typecodecs/uint64codec.cpp
  view/poddecoder/typecodecs/sint8codec.cpp
  view/poddecoder/typecodecs/sint16codec.cpp
  view/poddecoder/typecodecs/sint32codec.cpp
  view/poddecoder/typecodecs/sint64codec.cpp
  view/poddecoder/typecodecs/float32codec.cpp
  view/poddecoder/typecodecs/float64codec.cpp
  view/poddecoder/typecodecs/char8codec.cpp
  view/poddecoder/typecodecs/utf8codec.cpp
  view/poddecoder/poddata.cpp
  view/poddecoder/poddecodertool.cpp
  view/poddecoder/podtablemodel.cpp
  view/poddecoder/poddelegate.cpp
  view/poddecoder/podtableview.cpp
  view/poddecoder/poddecodertoolview.cpp
  view/poddecoder/poddecodertoolfactory.cpp
  view/poddecoder/poddecodertoolviewfactory.cpp
)
oktetakastencontrollers_generate_headers(poddecodercontroller view/poddecoder
  PODData
  PODDecoderTool
  PODDecoderToolView
  PODDecoderToolFactory
  PODDecoderToolViewFactory
)

set( PODDECODER_TYPEEDITOR_SRCS
  view/poddecoder/typeeditors/abstractvalue8editor.cpp
  view/poddecoder/typeeditors/binary8editor.cpp
  view/poddecoder/typeeditors/octal8editor.cpp
  view/poddecoder/typeeditors/hexadecimal8editor.cpp
  view/poddecoder/typeeditors/uintspinbox.cpp
  view/poddecoder/typeeditors/sintspinbox.cpp
  view/poddecoder/typeeditors/float32editor.cpp
  view/poddecoder/typeeditors/float64editor.cpp
  view/poddecoder/typeeditors/char8editor.cpp
  view/poddecoder/typeeditors/utf8editor.cpp
)

set( BYTETABLECONTROLLER_SRCS
  view/bytetable/bytetablemodel.cpp
  view/bytetable/bytetabletool.cpp
  view/bytetable/bytetableview.cpp
  view/bytetable/bytetabletoolview.cpp
  view/bytetable/bytetabletoolfactory.cpp
  view/bytetable/bytetabletoolviewfactory.cpp
)
kconfig_add_kcfg_files( BYTETABLECONTROLLER_SRCS view/bytetable/bytetableviewsettings.kcfgc )
oktetakastencontrollers_generate_headers(bytetablecontroller view/bytetable
  ByteTableTool
  ByteTableToolView
  ByteTableToolFactory
  ByteTableToolViewFactory
)

set( SEARCHCONTROLLER_SRCS
  view/search/ksearchdialog.cpp
  view/search/searchjob.cpp
  view/search/searchtool.cpp
  view/search/searchcontroller.cpp
)
oktetakastencontrollers_generate_headers(searchcontroller view/search
  SearchController
  SearchUserQueryable
)

set( REPLACECONTROLLER_SRCS
  view/replace/kreplacedialog.cpp
  view/replace/kreplaceprompt.cpp
  view/replace/replacetool.cpp
  view/replace/replacecontroller.cpp
)
oktetakastencontrollers_generate_headers(replacecontroller view/replace
  ReplaceController
  ReplaceUserQueryable
)

set( LIBFILTER_SRCS
  view/libbytearrayfilter/abstractbytearrayfilter.cpp
  view/libbytearrayfilter/abstractbytearrayfilterparameterset.cpp
  view/libbytearrayfilter/abstractbytearrayfilterparametersetedit.cpp
  view/libbytearrayfilter/bytearrayfilterfactory.cpp
  view/libbytearrayfilter/bytearrayfilterparameterseteditfactory.cpp
  view/libbytearrayfilter/filter/nobytearrayfilterparameterset.cpp
  view/libbytearrayfilter/filter/operandbytearrayfilterparameterset.cpp
  view/libbytearrayfilter/filter/reversebytearrayfilterparameterset.cpp
  view/libbytearrayfilter/filter/rotatebytearrayfilterparameterset.cpp
## NEWFILTERPARAMETERSET(start)
## Here add the names of your source files of your filter parameter set,
## e.g.
##  view/libbytearrayfilter/filter/mybytearrayfilterparameterset.cpp
## NEWFILTERPARAMETERSET(end)
  view/libbytearrayfilter/filter/andbytearrayfilter.cpp
  view/libbytearrayfilter/filter/orbytearrayfilter.cpp
  view/libbytearrayfilter/filter/xorbytearrayfilter.cpp
  view/libbytearrayfilter/filter/invertbytearrayfilter.cpp
  view/libbytearrayfilter/filter/reversebytearrayfilter.cpp
  view/libbytearrayfilter/filter/rotatebytearrayfilter.cpp
  view/libbytearrayfilter/filter/shiftbytearrayfilter.cpp
## NEWFILTER(start)
## Here add the names of your source files of your filter,
## e.g.
##   view/libbytearrayfilter/filter/mybytearrayfilter.cpp
## NEWFILTER(end)
  view/libbytearrayfilter/filter/nobytearrayfilterparametersetedit.cpp
  view/libbytearrayfilter/filter/operandbytearrayfilterparametersetedit.cpp
  view/libbytearrayfilter/filter/reversebytearrayfilterparametersetedit.cpp
  view/libbytearrayfilter/filter/rotatebytearrayfilterparametersetedit.cpp
## NEWFILTERPARAMETERSET(start)
## Here add the names of your source files of your widget to edit the filter parameter set,
## e.g.
##   view/libbytearrayfilter/filter/mybytearrayfilterparametersetedit.cpp
## NEWFILTERPARAMETERSET(end)
)
set( FILTERCONTROLLER_SRCS
  view/filter/filterjob.cpp
  view/filter/filtertool.cpp
  view/filter/filterview.cpp
  view/filter/filtertoolview.cpp
  view/filter/filtertoolfactory.cpp
  view/filter/filtertoolviewfactory.cpp
)
oktetakastencontrollers_generate_headers(filtercontroller view/filter
  FilterTool
  FilterToolView
  FilterToolFactory
  FilterToolViewFactory
)

set( CHARSETCONVERSIONTOOL_SRCS
  view/charsetconversion/charsetconversionjob.cpp
  view/charsetconversion/charsetconversiontool.cpp
  view/charsetconversion/charsetconversionview.cpp
  view/charsetconversion/charsetconversiontoolview.cpp
  view/charsetconversion/charsetconversiontoolfactory.cpp
  view/charsetconversion/charsetconversiontoolviewfactory.cpp
)
oktetakastencontrollers_generate_headers(charsetconversiontool view/charsetconversion
  CharsetConversionTool
  CharsetConversionToolView
  CharsetConversionToolFactory
  CharsetConversionToolViewFactory
)

set( GOTOOFFSETCONTROLLER_SRCS
  view/gotooffset/gotooffsettool.cpp
  view/gotooffset/gotooffsetview.cpp
  view/gotooffset/gotooffsettoolview.cpp
  view/gotooffset/gotooffsetcontroller.cpp
)
oktetakastencontrollers_generate_headers(gotooffsetcontroller view/gotooffset
  GotoOffsetController
)

set( SELECTRANGECONTROLLER_SRCS
  view/selectrange/selectrangetool.cpp
  view/selectrange/selectrangeview.cpp
  view/selectrange/selectrangetoolview.cpp
  view/selectrange/selectrangecontroller.cpp
)
oktetakastencontrollers_generate_headers(selectrangecontroller view/selectrange
  SelectRangeController
)

set( BOOKMARKSCONTROLLER_SRCS
  view/bookmarks/bookmarkeditpopup.cpp
  view/bookmarks/bookmarkscontroller.cpp
)
oktetakastencontrollers_generate_headers(bookmarkscontroller view/bookmarks
  BookmarksController
)

set( BOOKMARKSTOOL_SRCS
  view/bookmarks/bookmarklistmodel.cpp
  view/bookmarks/bookmarkstool.cpp
  view/bookmarks/bookmarksview.cpp
  view/bookmarks/bookmarkstoolview.cpp
  view/bookmarks/bookmarkstoolfactory.cpp
  view/bookmarks/bookmarkstoolviewfactory.cpp
)
oktetakastencontrollers_generate_headers(bookmarkstool view/bookmarks
  BookmarksTool
  BookmarksToolView
  BookmarksToolFactory

=== kasten/core/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"liboktetakasten\")

ecm_setup_version( ${OKTETAKASTEN_LIB_VERSION}
    VARIABLE_PREFIX OKTETAKASTENCORE
    SOVERSION ${OKTETAKASTEN_LIB_SOVERSION}
    PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/OktetaKastenCoreConfigVersion.cmake"
)

include_directories(
  document
)

set( okteta_kastencore_document_SRCS
  document/bytearraydocumentfactory.cpp
  document/bytearraydocument.cpp
  document/bytearrayselection.cpp
)
ecm_generate_headers(OKTETA_KASTEN_CORE_DOCUMENT_CCHDRS
  HEADER_NAMES
    ByteArrayDocumentFactory
    ByteArrayDocument
    ByteArraySelection
  RELATIVE document
  PREFIX Kasten/Okteta
  REQUIRED_HEADERS OKTETA_KASTEN_CORE_DOCUMENT_HDRS
)

set( okteta_kastencore_io_filesystem_SRCS
#   io/filesystem/externalbookmarkstorage.cpp
  io/filesystem/bytearrayrawfileloadthread.cpp
  io/filesystem/bytearrayrawfilereloadthread.cpp
  io/filesystem/bytearrayrawfilewritethread.cpp
  io/filesystem/bytearrayrawfileloadjob.cpp
  io/filesystem/bytearrayrawfileconnectjob.cpp
  io/filesystem/bytearrayrawfilewritejob.cpp
  io/filesystem/bytearrayrawfilereloadjob.cpp
  io/filesystem/bytearrayrawfilewritetojob.cpp
  io/filesystem/bytearrayrawfilesynchronizer.cpp
  io/filesystem/bytearrayrawfilesynchronizerfactory.cpp
)
ecm_generate_headers(OKTETA_KASTEN_CORE_IO_FILESYSTEM_CCHDRS
  HEADER_NAMES
    ByteArrayRawFileSynchronizer
    ByteArrayRawFileSynchronizerFactory
  RELATIVE io/filesystem
  PREFIX Kasten/Okteta
  REQUIRED_HEADERS OKTETA_KASTEN_CORE_IO_FILESYSTEM_HDRS
)


set( okteta_kastencore_io_SRCS
  ${okteta_kastencore_io_filesystem_SRCS}
)
set( OKTETA_KASTEN_CORE_IO_HDRS
  ${OKTETA_KASTEN_CORE_IO_FILESYSTEM_HDRS}
)
set( OKTETA_KASTEN_CORE_IO_CCHDRS
  ${OKTETA_KASTEN_CORE_IO_FILESYSTEM_CCHDRS}
)

set( okteta_kastencore_LIB_SRCS
  ${okteta_kastencore_document_SRCS}
  ${okteta_kastencore_io_SRCS}
)

set( okteta_kastencore_LIB_HDRS
  ${CMAKE_CURRENT_BINARY_DIR}/kasten/okteta/oktetakastencore_export.h
  ${OKTETA_KASTEN_CORE_DOCUMENT_HDRS}
  ${OKTETA_KASTEN_CORE_IO_HDRS}
)

set( okteta_kastencore_LIB_CCHDRS
  ${OKTETA_KASTEN_CORE_DOCUMENT_CCHDRS}
  ${OKTETA_KASTEN_CORE_IO_CCHDRS}
)

add_library( OktetaKastenCore  SHARED ${okteta_kastencore_LIB_SRCS} )

generate_export_header( OktetaKastenCore EXPORT_FILE_NAME ${CMAKE_CURRENT_BINARY_DIR}/kasten/okteta/oktetakastencore_export.h)

target_link_libraries( OktetaKastenCore
PUBLIC
  KastenCore
  OktetaCore
PRIVATE
  KF5::I18n
  KF5::Bookmarks
)

target_include_directories(OktetaKastenCore PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>")

set_target_properties( OktetaKastenCore PROPERTIES
  EXPORT_NAME "OktetaKastenCore"
  OUTPUT_NAME kasten${KASTEN_ABI_VERSION}okteta${OKTETAKASTEN_ABI_VERSION}core
  VERSION     ${OKTETAKASTENCORE_VERSION}
  SOVERSION   ${OKTETAKASTENCORE_SOVERSION}
)

install( TARGETS OktetaKastenCore  EXPORT OktetaKastenCoreTargets ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} )

install( FILES ${okteta_kastencore_LIB_HDRS}
  DESTINATION ${OKTETAKASTEN_INCLUDE_INSTALL_DIR}
  COMPONENT Devel
)
install( FILES ${okteta_kastencore_LIB_CCHDRS}
  DESTINATION ${OKTETAKASTEN_CCINCLUDE_INSTALL_DIR}
  COMPONENT Devel
)

# create a Config.cmake and a ConfigVersion.cmake file and install them
set(CMAKECONFIG_INSTALL_DIR "${KDE_INSTALL_CMAKEPACKAGEDIR}/OktetaKastenCore")

configure_package_config_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/OktetaKastenCoreConfig.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/OktetaKastenCoreConfig.cmake"
  INSTALL_DESTINATION ${CMAKECONFIG_INSTALL_DIR}
)

install( FILES
    "${CMAKE_CURRENT_BINARY_DIR}/OktetaKastenCoreConfig.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/OktetaKastenCoreConfigVersion.cmake"
  DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
  COMPONENT Devel
)

install(EXPORT OktetaKastenCoreTargets
  DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
  FILE OktetaKastenCoreTargets.cmake
)


if(BUILD_TESTING)
  add_subdirectory(document/tests)
  add_subdirectory(io/tests)
endif(BUILD_TESTING)

=== kasten/gui/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"liboktetakasten\")

ecm_setup_version( ${OKTETAKASTEN_LIB_VERSION}
    VARIABLE_PREFIX OKTETAKASTENGUI
    SOVERSION ${OKTETAKASTEN_LIB_SOVERSION}
    PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/OktetaKastenGuiConfigVersion.cmake"
)

macro(OKTETAKASTENGUI_GENERATE_HEADERS _SUBLIB _RELATIVE)
    ecm_generate_headers("${_SUBLIB}_CCHDRS"
        HEADER_NAMES ${ARGN}
        RELATIVE ${_RELATIVE}
        PREFIX Kasten/Okteta
        REQUIRED_HEADERS "${_SUBLIB}_HDRS"
    )
endmacro()

include_directories(
  system
  io
  view
  io/streamencoder
  liboktetawidgets
)

set( liboktetawidgets_SRCS
  liboktetawidgets/bytearrayvalidator.cpp
  liboktetawidgets/bytearraycombobox_p.cpp
  liboktetawidgets/bytearraycombobox.cpp
  liboktetawidgets/addressvalidator.cpp
  liboktetawidgets/addresscombobox_p.cpp
  liboktetawidgets/addresscombobox.cpp
)
oktetakastengui_generate_headers(liboktetawidgets liboktetawidgets
  AddressValidator
  AddressComboBox
  ByteArrayComboBox
)

set( okteta_values_streamencoder_SRCS
  io/streamencoder/values/bytearrayvaluesstreamencoderconfigeditor.cpp
  io/streamencoder/values/bytearrayvaluesstreamencoderconfigeditorfactory.cpp
  io/streamencoder/values/bytearrayvaluesstreamencoder.cpp
)

set( okteta_base32_streamencoder_SRCS
  io/streamencoder/base32/bytearraybase32streamencoderconfigeditor.cpp
  io/streamencoder/base32/bytearraybase32streamencoderconfigeditorfactory.cpp
  io/streamencoder/base32/bytearraybase32streamencoder.cpp
)

set( okteta_uuencoding_streamencoder_SRCS
  io/streamencoder/uuencoding/bytearrayuuencodingstreamencoderconfigeditor.cpp
  io/streamencoder/uuencoding/bytearrayuuencodingstreamencoderconfigeditorfactory.cpp
  io/streamencoder/uuencoding/bytearrayuuencodingstreamencoder.cpp
)

set( okteta_xxencoding_streamencoder_SRCS
  io/streamencoder/xxencoding/bytearrayxxencodingstreamencoderconfigeditor.cpp
  io/streamencoder/xxencoding/bytearrayxxencodingstreamencoderconfigeditorfactory.cpp
  io/streamencoder/xxencoding/bytearrayxxencodingstreamencoder.cpp
)

set( okteta_sourcecode_streamencoder_SRCS
  io/streamencoder/sourcecode/bytearraysourcecodestreamencoderconfigeditor.cpp
  io/streamencoder/sourcecode/bytearraysourcecodestreamencoderconfigeditorfactory.cpp
  io/streamencoder/sourcecode/bytearraysourcecodestreamencoder.cpp
)

set( okteta_srec_streamencoder_SRCS
  io/streamencoder/srec/bytearraysrecstreamencoderconfigeditor.cpp
  io/streamencoder/srec/bytearraysrecstreamencoderconfigeditorfactory.cpp
  io/streamencoder/srec/bytearraysrecstreamencoder.cpp
)

set( okteta_ihex_streamencoder_SRCS
  io/streamencoder/ihex/bytearrayihexstreamencoderconfigeditor.cpp
  io/streamencoder/ihex/bytearrayihexstreamencoderconfigeditorfactory.cpp
  io/streamencoder/ihex/bytearrayihexstreamencoder.cpp
)

set( okteta_viewtext_streamencoder_SRCS
  io/streamencoder/viewtext/abstractcolumntextrenderer.cpp
  io/streamencoder/viewtext/offsetcolumntextrenderer.cpp
  io/streamencoder/viewtext/bordercolumntextrenderer.cpp
  io/streamencoder/viewtext/abstractbytearraycolumntextrenderer.cpp
  io/streamencoder/viewtext/valuebytearraycolumntextrenderer.cpp
  io/streamencoder/viewtext/charbytearraycolumntextrenderer.cpp
  io/streamencoder/viewtext/bytearrayrowscolumntextrenderer.cpp
  io/streamencoder/viewtext/bytearrayviewtextstreamencoder.cpp
)

set( okteta_streamencoder_SRCS
  io/streamencoder/abstractbytearraystreamencoder.cpp
  io/streamencoder/bytearraytextstreamencoderpreview.cpp
  ${okteta_values_streamencoder_SRCS}
  io/streamencoder/chars/bytearraycharsstreamencoder.cpp
  io/streamencoder/base64/bytearraybase64streamencoder.cpp
  ${okteta_base32_streamencoder_SRCS}
  io/streamencoder/base85/bytearraybase85streamencoder.cpp
  ${okteta_uuencoding_streamencoder_SRCS}
  ${okteta_xxencoding_streamencoder_SRCS}
  ${okteta_srec_streamencoder_SRCS}
  ${okteta_ihex_streamencoder_SRCS}
  ${okteta_sourcecode_streamencoder_SRCS}
  ${okteta_viewtext_streamencoder_SRCS}
  io/bytearraystreamencoderfactory.cpp
  io/bytearraystreamencoderconfigeditorfactoryfactory.cpp
)
oktetakastengui_generate_headers(okteta_streamencoder io/streamencoder
  AbstractByteArrayStreamEncoder
)
oktetakastengui_generate_headers(okteta_streamencoder io
  ByteArrayStreamEncoderFactory
  ByteArrayStreamEncoderConfigEditorFactoryFactory
)

set( okteta_pattern_datagenerator_SRCS
  io/generator/pattern/bytearraypatterngeneratorconfigeditor.cpp
  io/generator/pattern/bytearraypatterngeneratorconfigeditorfactory.cpp
  io/generator/pattern/bytearraypatterngenerator.cpp
)

set( okteta_randomdata_datagenerator_SRCS
  io/generator/randomdata/bytearrayrandomdatageneratorconfigeditor.cpp
  io/generator/randomdata/bytearrayrandomdatageneratorconfigeditorfactory.cpp
  io/generator/randomdata/bytearrayrandomdatagenerator.cpp
)

set( okteta_sequence_datagenerator_SRCS
  io/generator/sequence/bytearraysequencegenerator.cpp
)

set( okteta_datagenerator_SRCS
  ${okteta_randomdata_datagenerator_SRCS}
  ${okteta_pattern_datagenerator_SRCS}
  ${okteta_sequence_datagenerator_SRCS}
  io/bytearraydatageneratorfactory.cpp
  io/bytearraydatageneratorconfigeditorfactoryfactory.cpp
)
oktetakastengui_generate_headers(okteta_datagenerator io
  ByteArrayDataGeneratorFactory
  ByteArrayDataGeneratorConfigEditorFactoryFactory
)

set( okteta_viewprofile_io_SRCS
  io/bytearrayviewprofilesynchronizer.cpp
)
oktetakastengui_generate_headers(okteta_viewprofile_io io
  ByteArrayViewProfileSynchronizer
)

set( okteta_kastengui_io_SRCS
  ${okteta_streamencoder_SRCS}
  ${okteta_datagenerator_SRCS}
  ${okteta_viewprofile_io_SRCS}
)
set( okteta_kastengui_io_HDRS
  ${okteta_streamencoder_HDRS}
  ${okteta_datagenerator_HDRS}
  ${okteta_viewprofile_io_HDRS}
)
set( okteta_kastengui_io_CCHDRS
  ${okteta_streamencoder_CCHDRS}
  ${okteta_datagenerator_CCHDRS}
  ${okteta_viewprofile_io_CCHDRS}
)

set( okteta_kastengui_view_SRCS
  view/bytearrayjanusview.cpp
  view/bytearrayviewfactory.cpp
  view/bytearrayview.cpp
  view/bytearrayviewprofile.cpp
)
oktetakastengui_generate_headers(okteta_kastengui_view view
  ByteArrayViewFactory
  ByteArrayView
  ByteArrayViewProfile
)

set( okteta_kastengui_system_SRCS
  system/bytearrayviewprofilelock.cpp
  system/bytearrayviewprofilemanager.cpp
)
oktetakastengui_generate_headers(okteta_kastengui_system system
  ByteArrayViewProfileLock
  ByteArrayViewProfileManager
)

set( okteta_kastengui_SRCS
  oktetakastengui.cpp
)
ecm_generate_headers(okteta_kastengui_CCHDRS
  HEADER_NAMES
    OktetaKastenGui
  PREFIX Kasten/Okteta
  REQUIRED_HEADERS okteta_kastengui_HDRS
)

set( okteta_kastengui_LIB_SRCS
  ${liboktetawidgets_SRCS}
  ${okteta_kastengui_SRCS}
  ${okteta_kastengui_view_SRCS}
  ${okteta_kastengui_io_SRCS}
  ${okteta_kastengui_system_SRCS}
)

set( okteta_kastengui_LIB_HDRS
  ${CMAKE_CURRENT_BINARY_DIR}/kasten/okteta/oktetakastengui_export.h
  ${liboktetawidgets_HDRS}
  ${okteta_kastengui_HDRS}
  ${okteta_kastengui_view_HDRS}
  ${okteta_kastengui_io_HDRS}
  ${okteta_kastengui_system_HDRS}
)
set( okteta_kastengui_LIB_CCHDRS
  ${liboktetawidgets_CCHDRS}
  ${okteta_kastengui_CCHDRS}
  ${okteta_kastengui_view_CCHDRS}
  ${okteta_kastengui_io_CCHDRS}
  ${okteta_kastengui_system_CCHDRS}
)

add_library( OktetaKastenGui  SHARED ${okteta_kastengui_LIB_SRCS} )

generate_export_header( OktetaKastenGui EXPORT_FILE_NAME ${CMAKE_CURRENT_BINARY_DIR}/kasten/okteta/oktetakastengui_export.h )

target_link_libraries( OktetaKastenGui
PUBLIC
  OktetaKastenCore
  KastenGui
  OktetaGui
PRIVATE
  Qt5::Qml
  KF5::I18n
  KF5::Completion
)

target_include_directories(OktetaKastenGui PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>")

set_target_properties( OktetaKastenGui  PROPERTIES
  EXPORT_NAME "OktetaKastenGui"
  OUTPUT_NAME kasten${KASTEN_ABI_VERSION}okteta${OKTETAKASTEN_ABI_VERSION}gui
  VERSION     ${OKTETAKASTENGUI_VERSION}
  SOVERSION   ${OKTETAKASTENGUI_SOVERSION}
)

install( TARGETS OktetaKastenGui  EXPORT OktetaKastenGuiTargets ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} )

install( FILES ${okteta_kastengui_LIB_HDRS}
  DESTINATION ${OKTETAKASTEN_INCLUDE_INSTALL_DIR}
  COMPONENT Devel
)
install( FILES ${okteta_kastengui_LIB_CCHDRS}
  DESTINATION ${OKTETAKASTEN_CCINCLUDE_INSTALL_DIR}
  COMPONENT Devel
)

# create a Config.cmake and a ConfigVersion.cmake file and install them
set(CMAKECONFIG_INSTALL_DIR "${KDE_INSTALL_CMAKEPACKAGEDIR}/OktetaKastenGui")

configure_package_config_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/OktetaKastenGuiConfig.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/OktetaKastenGuiConfig.cmake"
  INSTALL_DESTINATION ${CMAKECONFIG_INSTALL_DIR}
)

install( FILES
    "${CMAKE_CURRENT_BINARY_DIR}/OktetaKastenGuiConfig.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/OktetaKastenGuiConfigVersion.cmake"
  DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
  COMPONENT Devel
)

install(EXPORT OktetaKastenGuiTargets
  DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
  FILE OktetaKastenGuiTargets.cmake
)

=== libs/kasten/controllers/CMakeLists.txt ===
ecm_setup_version( ${KASTEN_LIB_VERSION}
    VARIABLE_PREFIX KASTENCONTROLLERS
    SOVERSION ${KASTEN_LIB_SOVERSION}
    PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/KastenControllersConfigVersion.cmake"
)

add_definitions(-DTRANSLATION_DOMAIN=\"libkasten\")

macro(KASTENCONTROLLERS_GENERATE_HEADERS _SUBLIB _RELATIVE)
    ecm_generate_headers("${_SUBLIB}_CCHDRS"
        HEADER_NAMES ${ARGN}
        RELATIVE ${_RELATIVE}
        PREFIX Kasten
        REQUIRED_HEADERS "${_SUBLIB}_HDRS"
    )
endmacro()

set( SYNCHRONIZECONTROLLER_SRCS
  io/synchronize/synchronizecontroller.cpp
)
kastencontrollers_generate_headers(SYNCHRONIZECONTROLLER io/synchronize
  SynchronizeController
)

set( SETREMOTECONTROLLER_SRCS
  io/setremote/setremotecontroller.cpp
)
kastencontrollers_generate_headers(SETREMOTECONTROLLER io/setremote
  SetRemoteController
)

set( CREATORCONTROLLER_SRCS
  documentsystem/creator/creatorcontroller.cpp
)
kastencontrollers_generate_headers(CREATORCONTROLLER documentsystem/creator
  CreatorController
)

set( LOADERCONTROLLER_SRCS
  documentsystem/loader/loadercontroller.cpp
)
kastencontrollers_generate_headers(LOADERCONTROLLER documentsystem/loader
  LoaderController
)

set( CLOSECONTROLLER_SRCS
  documentsystem/close/closecontroller.cpp
)
kastencontrollers_generate_headers(CLOSECONTROLLER documentsystem/close
  CloseController
)

set( FILESYSTEMBROWSERCONTROLLER_SRCS
  documentsystem/filesystembrowser/filesystembrowsertool.cpp
  documentsystem/filesystembrowser/filesystembrowserview.cpp
  documentsystem/filesystembrowser/filesystembrowsertoolview.cpp
)
kastencontrollers_generate_headers(FILESYSTEMBROWSERCONTROLLER documentsystem/filesystembrowser
  FileSystemBrowserTool
  FileSystemBrowserToolView
)

set( DOCUMENTSBROWSERCONTROLLER_SRCS
  documentsystem/documentsbrowser/documentlistmodel.cpp
  documentsystem/documentsbrowser/documentstool.cpp
  documentsystem/documentsbrowser/documentsview.cpp
  documentsystem/documentsbrowser/documentstoolview.cpp
)
kastencontrollers_generate_headers(DOCUMENTSBROWSERCONTROLLER documentsystem/documentsbrowser
  DocumentsTool
  DocumentsToolView
)

set( TERMINALCONTROLLER_SRCS
  document/terminal/terminaltool.cpp
  document/terminal/terminalview.cpp
  document/terminal/terminaltoolview.cpp
)
kastencontrollers_generate_headers(TERMINALCONTROLLER document/terminal
  TerminalTool
  TerminalToolView
)

set( MODIFIEDBARCONTROLLER_SRCS
  document/modified/modifiedbarcontroller.cpp
)
kastencontrollers_generate_headers(MODIFIEDBARCONTROLLER document/modified
  ModifiedBarController
)

set( READONLYCONTROLLER_SRCS
  document/readonly/readonlycontroller.cpp
)
kastencontrollers_generate_headers(READONLYCONTROLLER document/readonly
  ReadOnlyController
)

set( READONLYBARCONTROLLER_SRCS
  document/readonly/readonlybarcontroller.cpp
)
kastencontrollers_generate_headers(READONLYBARCONTROLLER document/readonly
  ReadOnlyBarController
)

if(CMAKE_BUILD_TYPE_TOLOWER MATCHES release)
set( VERSIONVIEWCONTROLLER_SRCS )
else(CMAKE_BUILD_TYPE_TOLOWER MATCHES release)
set( VERSIONVIEWCONTROLLER_SRCS
  document/versionview/versiontablemodel.cpp
  document/versionview/versionview.cpp
  document/versionview/versionviewtool.cpp
  document/versionview/versionviewtoolview.cpp
)
kastencontrollers_generate_headers(VERSIONVIEWCONTROLLER document/versionview
  VersionViewTool
  VersionViewToolView
)
endif(CMAKE_BUILD_TYPE_TOLOWER MATCHES release)
set( VERSIONCONTROLLER_SRCS
  view/version/versioncontroller.cpp
)
kastencontrollers_generate_headers(VERSIONCONTROLLER view/version
  VersionController
)

set( ZOOMCONTROLLER_SRCS
  view/zoom/zoomcontroller.cpp
)
kastencontrollers_generate_headers(ZOOMCONTROLLER view/zoom
  ZoomController
)

set( ZOOMBARCONTROLLER_SRCS
  view/zoom/zoomslider.cpp
  view/zoom/zoombarcontroller.cpp
)
kastencontrollers_generate_headers(ZOOMBARCONTROLLER view/zoom
  ZoomBarController
)

set( SELECTCONTROLLER_SRCS
  view/select/selectcontroller.cpp
)
kastencontrollers_generate_headers(SELECTCONTROLLER view/select
  SelectController
)

set( CLIPBOARDCONTROLLER_SRCS
  io/clipboard/clipboardcontroller.cpp
)
kastencontrollers_generate_headers(CLIPBOARDCONTROLLER io/clipboard
  ClipboardController
)

set( INSERTCONTROLLER_SRCS
  io/insert/insertdialog.cpp
  io/insert/insertcontroller.cpp
)
kastencontrollers_generate_headers(INSERTCONTROLLER io/insert
  InsertController
)

set( COPYASCONTROLLER_SRCS
  io/copyas/copyasdialog.cpp
  io/copyas/copyascontroller.cpp
)
kastencontrollers_generate_headers(COPYASCONTROLLER io/copyas
  CopyAsController
)

set( EXPORTCONTROLLER_SRCS
  io/export/exportdialog.cpp
  io/export/exportcontroller.cpp
)
kastencontrollers_generate_headers(EXPORTCONTROLLER io/export
  ExportController
)

# set( CLOSECONTROLLER_SRCS
#   viewsystem/close/closecontroller.cpp
# )
set( SWITCHVIEWCONTROLLER_SRCS
  shellwindow/switchview/switchviewcontroller.cpp
)
kastencontrollers_generate_headers(SWITCHVIEWCONTROLLER shellwindow/switchview
  SwitchViewController
)

set( VIEWLISTMENUCONTROLLER_SRCS
  shellwindow/viewlistmenu/viewlistmenucontroller.cpp
)
kastencontrollers_generate_headers(VIEWLISTMENUCONTROLLER shellwindow/viewlistmenu
  ViewListMenuController
)

set( VIEWAREASPLITCONTROLLER_SRCS
  shellwindow/viewareasplit/viewareasplitcontroller.cpp
)
kastencontrollers_generate_headers(VIEWAREASPLITCONTROLLER shellwindow/viewareasplit
  ViewAreaSplitController
)

set( TOOLLISTMENUCONTROLLER_SRCS
  shellwindow/toollistmenu/toollistmenucontroller.cpp
)
kastencontrollers_generate_headers(TOOLLISTMENUCONTROLLER shellwindow/toollistmenu
  ToolListMenuController
)

set( FULLSCREENCONTROLLER_SRCS
  shellwindow/fullscreen/fullscreencontroller.cpp
)
kastencontrollers_generate_headers(FULLSCREENCONTROLLER shellwindow/fullscreen
  FullScreenController
)

set( QUITCONTROLLER_SRCS
  program/quit/quitcontroller.cpp
)
kastencontrollers_generate_headers(QUITCONTROLLER program/quit
  QuitController
)

set( kastencontrollers_LIB_SRCS
  ${SETREMOTECONTROLLER_SRCS}
  ${CLOSECONTROLLER_SRCS}
  ${FILESYSTEMBROWSERCONTROLLER_SRCS}
  ${DOCUMENTSBROWSERCONTROLLER_SRCS}
  ${TERMINALCONTROLLER_SRCS}
  ${VERSIONCONTROLLER_SRCS}
  ${VERSIONVIEWCONTROLLER_SRCS}
  ${MODIFIEDBARCONTROLLER_SRCS}
  ${READONLYCONTROLLER_SRCS}
  ${READONLYBARCONTROLLER_SRCS}
  ${SWITCHVIEWCONTROLLER_SRCS}
  ${VIEWLISTMENUCONTROLLER_SRCS}
  ${VIEWAREASPLITCONTROLLER_SRCS}
  ${TOOLLISTMENUCONTROLLER_SRCS}
  ${FULLSCREENCONTROLLER_SRCS}
  ${ZOOMCONTROLLER_SRCS}
  ${ZOOMBARCONTROLLER_SRCS}
  ${CREATORCONTROLLER_SRCS}
  ${LOADERCONTROLLER_SRCS}
  ${SYNCHRONIZECONTROLLER_SRCS}
  ${SELECTCONTROLLER_SRCS}
  ${CLIPBOARDCONTROLLER_SRCS}
  ${INSERTCONTROLLER_SRCS}
  ${COPYASCONTROLLER_SRCS}
  ${EXPORTCONTROLLER_SRCS}
  ${QUITCONTROLLER_SRCS}
)

set( kastencontrollers_LIB_HDRS
  ${CMAKE_CURRENT_BINARY_DIR}/kasten/kastencontrollers_export.h
  ${SETREMOTECONTROLLER_HDRS}
  ${CLOSECONTROLLER_HDRS}
  ${FILESYSTEMBROWSERCONTROLLER_HDRS}
  ${DOCUMENTSBROWSERCONTROLLER_HDRS}
  ${TERMINALCONTROLLER_HDRS}
  ${VERSIONCONTROLLER_HDRS}
  ${VERSIONVIEWCONTROLLER_HDRS}
  ${MODIFIEDBARCONTROLLER_HDRS}
  ${READONLYCONTROLLER_HDRS}
  ${READONLYBARCONTROLLER_HDRS}
  ${SWITCHVIEWCONTROLLER_HDRS}
  ${VIEWLISTMENUCONTROLLER_HDRS}
  ${VIEWAREASPLITCONTROLLER_HDRS}
  ${TOOLLISTMENUCONTROLLER_HDRS}
  ${FULLSCREENCONTROLLER_HDRS}
  ${ZOOMCONTROLLER_HDRS}
  ${ZOOMBARCONTROLLER_HDRS}
  ${CREATORCONTROLLER_HDRS}
  ${LOADERCONTROLLER_HDRS}
  ${SYNCHRONIZECONTROLLER_HDRS}
  ${SELECTCONTROLLER_HDRS}
  ${CLIPBOARDCONTROLLER_HDRS}
  ${INSERTCONTROLLER_HDRS}
  ${COPYASCONTROLLER_HDRS}
  ${EXPORTCONTROLLER_HDRS}
  ${QUITCONTROLLER_HDRS}
)

set( kastencontrollers_LIB_CCHDRS
  ${SETREMOTECONTROLLER_CCHDRS}
  ${CLOSECONTROLLER_CCHDRS}
  ${FILESYSTEMBROWSERCONTROLLER_CCHDRS}
  ${DOCUMENTSBROWSERCONTROLLER_CCHDRS}
  ${TERMINALCONTROLLER_CCHDRS}
  ${VERSIONCONTROLLER_CCHDRS}
  ${VERSIONVIEWCONTROLLER_CCHDRS}
  ${MODIFIEDBARCONTROLLER_CCHDRS}
  ${READONLYCONTROLLER_CCHDRS}
  ${READONLYBARCONTROLLER_CCHDRS}
  ${SWITCHVIEWCONTROLLER_CCHDRS}
  ${VIEWLISTMENUCONTROLLER_CCHDRS}
  ${VIEWAREASPLITCONTROLLER_CCHDRS}
  ${TOOLLISTMENUCONTROLLER_CCHDRS}
  ${FULLSCREENCONTROLLER_CCHDRS}
  ${ZOOMCONTROLLER_CCHDRS}
  ${ZOOMBARCONTROLLER_CCHDRS}
  ${CREATORCONTROLLER_CCHDRS}
  ${LOADERCONTROLLER_CCHDRS}
  ${SYNCHRONIZECONTROLLER_CCHDRS}
  ${SELECTCONTROLLER_CCHDRS}
  ${CLIPBOARDCONTROLLER_CCHDRS}
  ${INSERTCONTROLLER_CCHDRS}
  ${COPYASCONTROLLER_CCHDRS}
  ${EXPORTCONTROLLER_CCHDRS}
  ${QUITCONTROLLER_CCHDRS}
)

add_library( KastenControllers SHARED ${kastencontrollers_LIB_SRCS} )
generate_export_header( KastenControllers EXPORT_FILE_NAME ${CMAKE_CURRENT_BINARY_DIR}/kasten/kastencontrollers_export.h)
target_link_libraries( KastenControllers
PUBLIC
  KastenGui
  KastenCore
PRIVATE
  KF5::I18n
  KF5::ConfigWidgets
  KF5::XmlGui
  KF5::KIOFileWidgets
  KF5::Parts
)

target_include_directories(KastenControllers PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>")

set_target_properties( KastenControllers  PROPERTIES
  EXPORT_NAME "KastenControllers"
  OUTPUT_NAME kasten${KASTEN_ABI_VERSION}controllers
  VERSION     ${KASTENCONTROLLERS_VERSION}
  SOVERSION   ${KASTENCONTROLLERS_SOVERSION}
)

install( TARGETS KastenControllers  EXPORT KastenControllersTargets ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} )

install( FILES ${kastencontrollers_LIB_HDRS}
  DESTINATION ${KASTEN_INCLUDE_INSTALL_DIR}
  COMPONENT   Devel
)
install( FILES ${kastencontrollers_LIB_CCHDRS}
  DESTINATION ${KASTEN_CCINCLUDE_INSTALL_DIR}
  COMPONENT Devel
)

# create a Config.cmake and a ConfigVersion.cmake file and install them
set(CMAKECONFIG_INSTALL_DIR "${KDE_INSTALL_CMAKEPACKAGEDIR}/KastenControllers")

configure_package_config_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/KastenControllersConfig.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/KastenControllersConfig.cmake"
  INSTALL_DESTINATION ${CMAKECONFIG_INSTALL_DIR}
)

install( FILES
    "${CMAKE_CURRENT_BINARY_DIR}/KastenControllersConfig.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/KastenControllersConfigVersion.cmake"
  DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
  COMPONENT Devel
)

install(EXPORT KastenControllersTargets
  DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
  FILE KastenControllersTargets.cmake
)

=== libs/kasten/core/CMakeLists.txt ===
ecm_setup_version( ${KASTEN_LIB_VERSION}
    VARIABLE_PREFIX KASTENCORE
    SOVERSION ${KASTEN_LIB_SOVERSION}
    PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/KastenCoreConfigVersion.cmake"
)

add_definitions(-DTRANSLATION_DOMAIN=\"libkasten\")

include_directories(
  entity
  document
  io
  io/filesystem
  system
)

set( KASTEN_CORE_ENTITY_SRCS
#   entity/group.cpp
  entity/person.cpp
#   entity/abstractentity.cpp
)
ecm_generate_headers(KASTEN_CORE_ENTITY_CCHDRS
  HEADER_NAMES
    Person
  RELATIVE entity
  PREFIX Kasten
  REQUIRED_HEADERS KASTEN_CORE_ENTITY_HDRS
)

set( KASTEN_CORE_DOCUMENT_SRCS
  document/abstractmodel.cpp
  document/abstractmodelselection.cpp
  document/abstracttool.cpp
  document/abstractdocument.cpp
  document/abstractdocumentfactory.cpp
  document/documentversiondata.cpp
)
set( KASTEN_CORE_DOCUMENT_HDRS
  document/documentversionid.h
)
ecm_generate_headers(KASTEN_CORE_DOCUMENT_CCHDRS
  HEADER_NAMES
    AbstractModel
    AbstractModelSelection
    AbstractDocument
    AbstractDocumentFactory
    AbstractTool
    AbstractToolFactory
    DocumentVersionId
    DocumentVersionData
    Versionable
    UserListable
  RELATIVE document
  PREFIX Kasten
  REQUIRED_HEADERS KASTEN_CORE_DOCUMENT_HDRS
)

set( KASTEN_CORE_IO_SRCS
  io/abstractloadjob.cpp
  io/abstractconnectjob.cpp
  io/abstractsynctoremotejob.cpp
  io/abstractsyncfromremotejob.cpp
  io/abstractsyncwithremotejob.cpp
  io/abstractmodelstreamencoder.cpp
  io/abstractexportjob.cpp
  io/abstractmodelexporter.cpp
  io/modeldatageneratethread.cpp
  io/abstractmodeldatagenerator.cpp
  io/modelstreamencodethread.cpp
  io/abstractmodelsynchronizer.cpp
  io/abstractmodelsynchronizerfactory.cpp
)
ecm_generate_headers(KASTEN_CORE_IO_CCHDRS
  HEADER_NAMES
    AbstractSyncToRemoteJob
    AbstractModelSynchronizer
    AbstractSyncWithRemoteJob
    AbstractSyncFromRemoteJob
    AbstractConnectJob
    AbstractModelStreamEncoder
    AbstractModelDataGenerator
    AbstractExportJob
    AbstractModelExporter
    ModelStreamEncodeThread
    ModelDataGenerateThread
    AbstractLoadJob
    AbstractModelSynchronizerFactory
  RELATIVE io
  PREFIX Kasten
  REQUIRED_HEADERS KASTEN_CORE_IO_HDRS
)

set( KASTEN_CORE_IO_FILESYSTEM_SRCS
  io/filesystem/abstractfilesystemloadjob_p.cpp
  io/filesystem/abstractfilesystemloadjob.cpp
  io/filesystem/abstractfilesystemsynctoremotejob_p.cpp
  io/filesystem/abstractfilesystemsynctoremotejob.cpp
  io/filesystem/abstractfilesystemsyncfromremotejob_p.cpp
  io/filesystem/abstractfilesystemsyncfromremotejob.cpp
  io/filesystem/abstractfilesystemsyncwithremotejob_p.cpp
  io/filesystem/abstractfilesystemsyncwithremotejob.cpp
  io/filesystem/abstractfilesystemconnectjob_p.cpp
  io/filesystem/abstractfilesystemconnectjob.cpp
  io/filesystem/abstractfilesystemexportjob_p.cpp
  io/filesystem/abstractfilesystemexportjob.cpp
  io/filesystem/modelencoderfilesystemexportjob_p.cpp
  io/filesystem/modelencoderfilesystemexportjob.cpp
  io/filesystem/modelencoderfilesystemexporter.cpp
  io/filesystem/abstractmodelfilesystemsynchronizer_p.cpp
  io/filesystem/abstractmodelfilesystemsynchronizer.cpp
)
ecm_generate_headers(KASTEN_CORE_IO_FILESYSTEM_CCHDRS
  HEADER_NAMES
    AbstractFileSystemSyncWithRemoteJob
    AbstractFileSystemSyncFromRemoteJob
    AbstractFileSystemSyncToRemoteJob
    AbstractModelFileSystemSynchronizer
    AbstractFileSystemConnectJob
    AbstractFileSystemLoadJob
    AbstractFileSystemExportJob
    ModelEncoderFileSystemExporter
    ModelEncoderFileSystemExportJob
  RELATIVE io/filesystem
  PREFIX Kasten
  REQUIRED_HEADERS KASTEN_CORE_IO_FILESYSTEM_HDRS
)

set( KASTEN_CORE_SYSTEM_SRCS
  system/jobmanager.cpp
  system/documentmanager.cpp
  system/documentcreatemanager.cpp
  system/documentsyncmanager.cpp
  system/modelcodecmanager.cpp
)
ecm_generate_headers(KASTEN_CORE_SYSTEM_CCHDRS
  HEADER_NAMES
    AbstractOverwriteDialog
    AbstractSaveDiscardDialog
    JobManager
    DocumentManager
    DocumentCreateManager
    DocumentSyncManager
    ModelCodecManager
  RELATIVE system
  PREFIX Kasten
  REQUIRED_HEADERS KASTEN_CORE_SYSTEM_HDRS
)
set( KASTEN_CORE_SRCS
  kastencore.cpp
)
ecm_generate_headers(KASTEN_CORE_CCHDRS
  HEADER_NAMES
    KastenCore
  PREFIX Kasten
  REQUIRED_HEADERS KASTEN_CORE_HDRS
)

set( kastencore_LIB_SRCS
  ${KASTEN_CORE_SRCS}
  ${KASTEN_CORE_ENTITY_SRCS}
  ${KASTEN_CORE_DOCUMENT_SRCS}
  ${KASTEN_CORE_IO_SRCS}
  ${KASTEN_CORE_IO_FILESYSTEM_SRCS}
  ${KASTEN_CORE_SYSTEM_SRCS}
)

set( kastencore_LIB_HDRS
  ${CMAKE_CURRENT_BINARY_DIR}/kasten/kastencore_export.h
  ${KASTEN_CORE_HDRS}
  ${KASTEN_CORE_ENTITY_HDRS}
  ${KASTEN_CORE_DOCUMENT_HDRS}
  ${KASTEN_CORE_IO_HDRS}
  ${KASTEN_CORE_IO_FILESYSTEM_HDRS}
  ${KASTEN_CORE_SYSTEM_HDRS}
)

set( kastencore_LIB_CCHDRS
  ${KASTEN_CORE_CCHDRS}
  ${KASTEN_CORE_ENTITY_CCHDRS}
  ${KASTEN_CORE_DOCUMENT_CCHDRS}
  ${KASTEN_CORE_IO_CCHDRS}
  ${KASTEN_CORE_IO_FILESYSTEM_CCHDRS}
  ${KASTEN_CORE_SYSTEM_CCHDRS}
)


add_library( KastenCore SHARED ${kastencore_LIB_SRCS} )
generate_export_header( KastenCore  EXPORT_FILE_NAME ${CMAKE_CURRENT_BINARY_DIR}/kasten/kastencore_export.h)
target_link_libraries( KastenCore
PUBLIC
  KF5::KIOCore
  Qt5::Core
  Qt5::Gui
PRIVATE
  KF5::I18n
  KF5::JobWidgets
  KF5::WidgetsAddons
  Qt5::Network
)

target_include_directories(KastenCore PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>")

set_target_properties( KastenCore PROPERTIES
  EXPORT_NAME "KastenCore"
  OUTPUT_NAME kasten${KASTEN_ABI_VERSION}core
  VERSION     ${KASTENCORE_VERSION}
  SOVERSION   ${KASTENCORE_SOVERSION}
)

install( TARGETS KastenCore  EXPORT KastenCoreTargets ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} )

install( FILES ${kastencore_LIB_HDRS}
  DESTINATION ${KASTEN_INCLUDE_INSTALL_DIR}
  COMPONENT   Devel
)
install( FILES ${kastencore_LIB_CCHDRS}
  DESTINATION ${KASTEN_CCINCLUDE_INSTALL_DIR}
  COMPONENT Devel
)

# create a Config.cmake and a ConfigVersion.cmake file and install them
set(CMAKECONFIG_INSTALL_DIR "${KDE_INSTALL_CMAKEPACKAGEDIR}/KastenCore")

configure_package_config_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/KastenCoreConfig.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/KastenCoreConfig.cmake"
  INSTALL_DESTINATION ${CMAKECONFIG_INSTALL_DIR}
)

install( FILES
    "${CMAKE_CURRENT_BINARY_DIR}/KastenCoreConfig.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/KastenCoreConfigVersion.cmake"
  DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
  COMPONENT Devel
)

install(EXPORT KastenCoreTargets
  DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
  FILE KastenCoreTargets.cmake
)


if(BUILD_TESTING)
  add_subdirectory( tests )
endif(BUILD_TESTING)

## okteta 0.25.4

=== debian/changelog ===
okteta (5:0.25.4-0ubuntu1) cosmic; urgency=medium

  * New upstream bugfix release (0.25.4)

 -- Rik Mills <rikmills@kubuntu.org>  Mon, 08 Oct 2018 13:00:13 +0100

okteta (5:0.25.3-0ubuntu1) cosmic; urgency=medium

  * New upstream release (0.25.3)

 -- Rik Mills <rikmills@kubuntu.org>  Sat, 22 Sep 2018 21:00:54 +0100

okteta (5:0.25.2-0ubuntu1) cosmic; urgency=medium

  * New upstream release (0.25.2)
  * Bump epoch to 5: as new release outside KDE Applications leaves
    behind apps versioning scheme.
  * Update watch file and add upstream signing key.
  * New build depend on qtdeclarative5-dev.
  * Update install files.
  * Update symbols from build logs.

 -- Rik Mills <rikmills@kubuntu.org>  Thu, 09 Aug 2018 13:24:42 +0100

okteta (4:17.12.3-0ubuntu1) bionic; urgency=medium

  * New upstream release (17.12.3)

 -- Rik Mills <rikmills@kubuntu.org>  Fri, 16 Mar 2018 13:33:57 +0000

okteta (4:17.12.2-0ubuntu1) bionic; urgency=medium

  * Update install file for changed plugin name
  * New upstream release (17.11.80)
  * New upstream release (17.11.90)
  * New upstream release (17.12.0)
  * New upstream release (17.12.2)

 -- Rik Mills <rikmills@kubuntu.org>  Thu, 22 Feb 2018 17:03:14 +0000

okteta (4:17.08.3-0ubuntu1) bionic; urgency=medium

  * New build depend on libkf5crash-dev
  * New upstream release (17.08.3)

 -- Rik Mills <rikmills@kubuntu.org>  Fri, 01 Dec 2017 15:13:31 +0000

okteta (4:17.04.3-0ubuntu1) artful; urgency=low

  * New upstream release (17.04.1)
  * Update symbols files
  * Install translations and add Breaks/Replaces against kde-l10n
  * New upstream release (17.04.2)
  * New upstream release (17.04.3)

 -- José Manuel Santamaría Lema <panfaust@gmail.com>  Fri, 18 Aug 2017 08:29:12 +0100

okteta (4:16.12.3-0ubuntu1) zesty; urgency=low

  [ Darin Miller ]
  * New upstream release (16.12.2)

  [ José Manuel Santamaría Lema ]
  * Pass '-fno-keep-inline-functions' to gcc in the acc test in order to
    avoid possible spurious test failures.
  * New upstream release (16.12.3)

 -- José Manuel Santamaría Lema <panfaust@gmail.com>  Fri, 10 Mar 2017 21:25:15 +0000

okteta (4:16.12.1-0ubuntu1) zesty; urgency=medium

  [ José Manuel Santamaría Lema ]
  * Update Vcs-Git fields to use https:// instead of git://

  [ Clive Johnston ]
  * Removing patches folder

  [ Rik Mills ]
  * New upstream release (16.12.0)
  * Update build deps to use new KF5 style names
  * Merge with debian
  * Update symbols from build logs
  * New upstream release (16.12.1)

 -- Rik Mills <rikmills@kubuntu.org>  Thu, 19 Jan 2017 16:13:56 +0000

okteta (4:16.08.3-1) unstable; urgency=medium

  * New upstream release (16.08.3)

 -- Maximiliano Curia <maxy@debian.org>  Wed, 23 Nov 2016 22:04:25 +0100

okteta (4:16.08.2-1) unstable; urgency=medium

  [ Automatic packaging ]
  * Update symbols files from buildds logs (4:16.08.0-2).
  * Update build-deps and deps with the info from cmake

  [ Maximiliano Curia ]
  * New upstream release (16.08.2)

 -- Maximiliano Curia <maxy@debian.org>  Tue, 18 Oct 2016 13:56:13 +0200

okteta (4:16.08.0-2) unstable; urgency=medium

  * Team upload.
  * Update symbols files.

 -- Pino Toscano <pino@debian.org>  Sat, 27 Aug 2016 22:14:18 +0200

okteta (4:16.08.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update okteta description from upstream. (Closes: #749674)
  * Update symbols files.
  * Bump the pkg-kde-tools build dependency to >= 0.15.23, so dh_sodeps can
    determine again the dependencies for okteta-dev.
  * Remove DEB_CFLAGS_MAINT_STRIP and DEB_CXXFLAGS_MAINT_STRIP from rules,
    as not much useful and most likely some workaround for an old bug.
  * Watch only stable releases.
  * Update install files.

 -- Pino Toscano <pino@debian.org>  Sat, 27 Aug 2016 10:46:21 +0200

okteta (4:16.04.3-0ubuntu2) yakkety; urgency=medium

  * Update symbols files properly so this package will build correctly on all
    Ubuntu architectures.

 -- José Manuel Santamaría Lema <panfaust@gmail.com>  Tue, 04 Oct 2016 18:36:13 +0100

okteta (4:16.04.3-0ubuntu1) yakkety; urgency=medium

  [ Scarlett Clark ]
  * New upstream release

  [ Philip Muškovac ]
  * Update the Vcs URLs now that the repositories are hosted on
    Launchpad

  [ Scarlett Clark ]
  * New upstream bugfix release

  [ Clive Johnston ]
  * Refreshing symbols
  * New upstream release (16.04.2)
  * New upstream release (16.04.3)
  * Removing optional symbols

  [ Rik Mills ]
  * New appstream data location

 -- José Manuel Santamaría Lema <panfaust@gmail.com>  Fri, 30 Sep 2016 06:36:46 +0200

okteta (4:16.04.2-1) unstable; urgency=medium

  [ Automatic packaging ]
  * Update symbols files from buildds logs (4:16.04.1-2).

 -- Maximiliano Curia <maxy@debian.org>  Thu, 23 Jun 2016 09:48:37 +0200

okteta (4:16.04.1-2) unstable; urgency=medium

  * Release to unstable.

 -- Maximiliano Curia <maxy@debian.org>  Tue, 31 May 2016 16:37:44 +0200

okteta (4:16.04.1-1) experimental; urgency=medium

  [ Automatic packaging ]
  * Bump Standards-Version to 3.9.8
  * Refresh patches
  * Update symbols files with the logs from the buildds
  * Update symbols files.

  [ Maximiliano Curia ]
  * New upstream release (15.12.2).
  * Drop patch: install_missing_header
  * Add upstream metadata (DEP-12)
  * debian/control: Update Vcs-Browser and Vcs-Git fields
  * Update testsuite script

 -- Maximiliano Curia <maxy@debian.org>  Thu, 26 May 2016 13:16:49 +0200

okteta (4:15.12.3-0ubuntu2) xenial; urgency=medium

  * Add so dependencies to okteta-dev as dh_sodeps
    is currently broken in pkg-kde-tools. Obviously
    that needs to be fixed. On TODO. 
  * Release to archive. 
  * Fix the new so deps with wrap-and-sort.

 -- Scarlett Clark <sgclark@kubuntu.org>  Mon, 18 Apr 2016 12:52:05 -0700

okteta (4:15.12.3-0ubuntu1) xenial; urgency=medium

  * New upstream bugfix release
  * Remove install_missing_header appears to be fixed upstream.
  * New upstream bugfix release



=== debian/control ===
Source: okteta
Section: kde
Priority: optional
Maintainer: Debian/Kubuntu Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Sune Vuorela <sune@debian.org>,
           Fathi Boudra <fabo@debian.org>,
           Modestas Vainius <modax@debian.org>,
           George Kiagiadakis <kiagiadakis.george@gmail.com>,
           Maximiliano Curia <maxy@debian.org>
Build-Depends: cmake (>= 2.8.12),
               debhelper (>= 9),
               extra-cmake-modules (>= 5.31.0~),
               libkf5bookmarks-dev (>= 5.31.0~),
               libkf5codecs-dev (>= 5.31.0~),
               libkf5completion-dev (>= 5.31.0~),
               libkf5configwidgets-dev (>= 5.31.0~),
               libkf5crash-dev (>= 5.31.0~),
               libkf5dbusaddons-dev (>= 5.31.0~),
               libkf5doctools-dev (>= 5.31.0~),
               libkf5i18n-dev (>= 5.31.0~),
               libkf5iconthemes-dev (>= 5.31.0~),
               libkf5kcmutils-dev (>= 5.31.0~),
               libkf5kio-dev (>= 5.31.0~),
               libkf5newstuff-dev (>= 5.31.0~),
               libkf5parts-dev (>= 5.31.0~),
               libkf5service-dev (>= 5.31.0~),
               libkf5widgetsaddons-dev (>= 5.31.0~),
               libkf5xmlgui-dev (>= 5.31.0~),
               libqca-qt5-2-dev (>= 2.1.0),
               pkg-config,
               pkg-kde-tools (>> 0.15.15),
               qtbase5-dev (>= 5.6.1~),
               qtdeclarative5-dev,
               qtscript5-dev (>= 5.6.1~),
               qttools5-dev (>= 5.6.1~),
               shared-mime-info (>= 0.30)
Standards-Version: 3.9.8
Homepage: http://www.kde.org/
Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/okteta
Vcs-Git: https://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/okteta

Package: okteta
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: ${kde-l10n:all}
Replaces: ${kde-l10n:all}
Description: hexadecimal editor for binary files
 Okteta is a simple editor for the raw data of files. This type of program is
 also called hexadecimal editor or binary editor.
 .
 The data is displayed in two variants: as the numeric values of the bytes
 and as the character assigned to the values. Values and characters can be
 shown either in two columns (the traditional display in hex editors) or in
 rows with the value on top of the character. Editing can be done both for
 the values and for the characters.
 .
 Besides the usual editing capabilities Okteta also brings a small set of
 tools, like a table listing decodings into common simple data types, a table
 listing all possible bytes with their character and value equivalents, an
 info view with a statistic, a checksum calculator, a filter tool and a string
 extraction tool.
 .
 This package is part of the KDE Software Development Kit module.

Package: okteta-dev
Architecture: any
Section: devel
Depends: libkasten3controllers3 (= ${binary:Version}),
         libkasten3core3 (= ${binary:Version}),
         libkasten3gui3 (= ${binary:Version}),
         libkasten3okteta1controllers1 (= ${binary:Version}),
         libkasten3okteta1core1 (= ${binary:Version}),
         libkasten3okteta1gui1 (= ${binary:Version}),
         libkf5xmlgui-dev (>= 5.31.0~),
         libokteta2core2 (= ${binary:Version}),
         libokteta2gui2 (= ${binary:Version}),
         okteta (= ${binary:Version}),
         qtbase5-dev (>= 5.6.1~),
         ${misc:Depends}
Description: Development files for Okteta
 Okteta is a simple editor for the raw data of files. This type of program is
 also called hexadecimal editor or binary editor.
 .
 This package contains the development files for Okteta.
 .
 This package is part of the KDE Software Development Kit module.

Package: libkasten3controllers3
Architecture: any
Section: libs
Depends: libokteta-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: controllers Kasten library for Okteta
 Kasten is a framework for composing programs.
 .
 This package provides the controller part of Kasten.
 .
 This package is part of the KDE Software Development Kit module.

Package: libkasten3core3
Architecture: any
Section: libs
Depends: libokteta-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: core Kasten library for Okteta
 Kasten is a framework for composing programs.
 .
 This package provides the core part of Kasten.
 .
 This package is part of the KDE Software Development Kit module.

Package: libkasten3gui3
Architecture: any
Section: libs
Depends: libokteta-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: gui Kasten library for Okteta
 Kasten is a framework for composing programs.
 .
 This package provides the GUI part of Kasten.
 .
 This package is part of the KDE Software Development Kit module.

Package: libokteta2core2
Architecture: any
Section: libs
Depends: libokteta-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: core Okteta library
 Okteta is a simple editor for the raw data of files. This type of program is
 also called hexadecimal editor or binary editor.
 .
 This package provides the core part of the Okteta libraries.
 .
 This package is part of the KDE Software Development Kit module.

Package: libokteta2gui2
Architecture: any
Section: libs
Depends: libokteta-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: gui Okteta library
 Okteta is a simple editor for the raw data of files. This type of program is
 also called hexadecimal editor or binary editor.
 .
 This package provides the GUI part of the Okteta libraries.
 .
 This package is part of the KDE Software Development Kit module.

Package: libkasten3okteta1controllers1
Architecture: any
Section: libs
Depends: libokteta-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: kastencontrollers library for Okteta
 Okteta is a simple editor for the raw data of files. This type of program is
 also called hexadecimal editor or binary editor.
 .
 This package provides the part of the Okteta libraries interfacing with Kasten
 controllers.
 .
 This package is part of the KDE Software Development Kit module.

Package: libkasten3okteta1core1
Architecture: any
Section: libs
Depends: libokteta-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: kastencore library for Okteta
 Okteta is a simple editor for the raw data of files. This type of program is
 also called hexadecimal editor or binary editor.
 .
 This package provides the part of the Okteta libraries interfacing
 with Kasten core.
 .
 This package is part of the KDE Software Development Kit module.

Package: libkasten3okteta1gui1
Architecture: any
Section: libs
Depends: libokteta-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: kastengui library for Okteta
 Okteta is a simple editor for the raw data of files. This type of program is
 also called hexadecimal editor or binary editor.
 .
 This package provides the part of the Okteta libraries interfacing
 with Kasten GUI.
 .
 This package is part of the KDE Software Development Kit module.

Package: libokteta-data
Architecture: all
Section: libs
Depends: ${misc:Depends}
Breaks: ${kde-l10n:all}
Replaces: ${kde-l10n:all}
Description: library data files for Okteta
 Okteta is a simple editor for the raw data of files. This type of program is
 also called hexadecimal editor or binary editor.
 .
 This package provides the part of the Okteta libraries interfacing
 with Kasten GUI.
 .
 This package is part of the KDE Software Development Kit module.

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.sig/ https://download.kde.org/stable/okteta/([\d.]+)/src/@PACKAGE@-([\d.]+).tar.xz
